<?php
/**
 * Revolution Video Vlog functions and definitions
 *
 * @package Revolution Video Vlog
 */

if ( ! defined( 'REVOLUTION_VIDEO_VLOG_VERSION' ) ) {
	// Replace the version number of the theme on each release.
	define( 'REVOLUTION_VIDEO_VLOG_VERSION', '1.0.0' );
}

function revolution_video_vlog_setup() {

	load_theme_textdomain( 'revolution-video-vlog', get_template_directory() . '/languages' );
	add_theme_support( 'automatic-feed-links' );
	add_theme_support( 'title-tag' );
	add_theme_support( 'post-thumbnails' );
	add_theme_support( 'woocommerce' );
	add_theme_support( "responsive-embeds" );
	add_theme_support( "align-wide" );

	register_nav_menus(
		array(
			'menu-1' => esc_html__( 'Primary', 'revolution-video-vlog' ),
			'social-menu' => esc_html__('Social Menu', 'revolution-video-vlog'),
		)
	);

	add_theme_support(
		'html5',
		array(
			'search-form',
			'comment-form',
			'comment-list',
			'gallery',
			'caption',
			'style',
			'script',
		)
	);

	add_theme_support(
		'custom-background',
		apply_filters(
			'revolution_video_vlog_custom_background_args',
			array(
				'default-color' => '#fafafa',
				'default-image' => '',
			)
		)
	);

	add_theme_support( 'customize-selective-refresh-widgets' );

	add_theme_support(
		'custom-logo',
		array(
			'height'      => 250,
			'width'       => 250,
			'flex-width'  => true,
			'flex-height' => true,
		)
	);

	add_theme_support( 'post-formats', array(
        'image',
        'video',
        'gallery',
        'audio', 
    ));	
	
}
add_action( 'after_setup_theme', 'revolution_video_vlog_setup' );

/**
 * Set the content width in pixels, based on the theme's design and stylesheet.
 *
 * Priority 0 to make it available to lower priority callbacks.
 *
 * @global int $revolution_video_vlog_content_width
 */
function revolution_video_vlog_content_width() {
	$GLOBALS['content_width'] = apply_filters( 'revolution_video_vlog_content_width', 640 );
}
add_action( 'after_setup_theme', 'revolution_video_vlog_content_width', 0 );

/**
 * Register widget area.
 *
 * @link https://developer.wordpress.org/themes/functionality/sidebars/#registering-a-sidebar
 */
function revolution_video_vlog_widgets_init() {
	register_sidebar(
		array(
			'name'          => esc_html__( 'Sidebar', 'revolution-video-vlog' ),
			'id'            => 'sidebar-1',
			'description'   => esc_html__( 'Add widgets here.', 'revolution-video-vlog' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);

	register_sidebar(
		array(
			'name'          => esc_html__( 'Footer 1', 'revolution-video-vlog' ),
			'id'            => 'footer-1',
			'description'   => esc_html__( 'Add widgets here.', 'revolution-video-vlog' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);

	register_sidebar(
		array(
			'name'          => esc_html__( 'Footer 2', 'revolution-video-vlog' ),
			'id'            => 'footer-2',
			'description'   => esc_html__( 'Add widgets here.', 'revolution-video-vlog' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);

	register_sidebar(
		array(
			'name'          => esc_html__( 'Footer 3', 'revolution-video-vlog' ),
			'id'            => 'footer-3',
			'description'   => esc_html__( 'Add widgets here.', 'revolution-video-vlog' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);

	register_sidebar(
		array(
			'name'          => esc_html__( 'Home Sidebar', 'revolution-video-vlog' ),
			'id'            => 'home',
			'description'   => esc_html__( 'Add widgets here.', 'revolution-video-vlog' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title">',
			'after_title'   => '</h2>',
		)
	);
}
add_action( 'widgets_init', 'revolution_video_vlog_widgets_init' );

function revolution_video_vlog_social_menu()
    {
        if (has_nav_menu('social-menu')) :
            wp_nav_menu(array(
                'theme_location' => 'social-menu',
                'container' => 'ul',
                'menu_class' => 'social-menu menu',
                'menu_id'  => 'menu-social',
            ));
        endif;
    }

/**
 * Enqueue scripts and styles.
 */
function revolution_video_vlog_scripts() {

	// Load fonts locally
	require_once get_theme_file_path('revolution/inc/wptt-webfont-loader.php');

	$revolution_video_vlog_font_families = array(
		'Mulish:ital,wght@0,200;0,300;0,400;0,500;0,600;0,700;0,800;0,900;0,1000;1,200;1,300;1,400;1,500;1,600;1,700;1,800;1,900;1,1000',
	);
	
	$revolution_video_vlog_fonts_url = add_query_arg( array(
		'family' => implode( '&family=', $revolution_video_vlog_font_families ),
		'display' => 'swap',
	), 'https://fonts.googleapis.com/css2' );

	wp_enqueue_style('revolution-video-vlog-google-fonts', wptt_get_webfont_url(esc_url_raw($revolution_video_vlog_fonts_url)), array(), '1.0.0');
	
	// Font Awesome CSS
    wp_enqueue_style('font-awesome-6', get_template_directory_uri() . '/revolution/assets/vendors/font-awesome-6/css/all.min.css', array(), '6.7.2');

	wp_enqueue_style('owl.carousel.style', get_template_directory_uri() . '/revolution/assets/css/owl.carousel.css', array());
	
	wp_enqueue_style( 'revolution-video-vlog-style', get_stylesheet_uri(), array(), REVOLUTION_VIDEO_VLOG_VERSION );

	require get_parent_theme_file_path( '/custom-style.php' );
	wp_add_inline_style( 'revolution-video-vlog-style',$revolution_video_vlog_custom_css );

	// RTL styles if needed
	wp_style_add_data('revolution-video-vlog-style', 'rtl', 'replace');

	wp_enqueue_script( 'revolution-video-vlog-navigation', get_template_directory_uri() . '/js/navigation.js', array(), REVOLUTION_VIDEO_VLOG_VERSION, true );

	wp_enqueue_script( 'owl.carousel.jquery', get_template_directory_uri() . '/revolution/assets/js/owl.carousel.js', array(), REVOLUTION_VIDEO_VLOG_VERSION, true );

	wp_enqueue_script( 'revolution-video-vlog-custom-js', get_template_directory_uri() . '/revolution/assets/js/custom.js', array('jquery'), REVOLUTION_VIDEO_VLOG_VERSION, true );

	if ( is_singular() && comments_open() && get_option( 'thread_comments' ) ) {
		wp_enqueue_script( 'comment-reply' );
	}
}
add_action( 'wp_enqueue_scripts', 'revolution_video_vlog_scripts' );

if (!function_exists('revolution_video_vlog_related_post')) :
    /**
     * Display related posts from same category
     *
     */

    function revolution_video_vlog_related_post($post_id){        
        $revolution_video_vlog_categories = get_the_category($post_id);
        if ($revolution_video_vlog_categories) {
            $revolution_video_vlog_category_ids = array();
            $revolution_video_vlog_category = get_category($revolution_video_vlog_category_ids);
            $revolution_video_vlog_categories = get_the_category($post_id);
            foreach ($revolution_video_vlog_categories as $revolution_video_vlog_category) {
                $revolution_video_vlog_category_ids[] = $revolution_video_vlog_category->term_id;
            }
            $revolution_video_vlog_count = $revolution_video_vlog_category->category_count;
            if ($revolution_video_vlog_count > 1) { ?>

         	<?php
		$revolution_video_vlog_related_post_wrap = absint(get_theme_mod('revolution_video_vlog_enable_related_post', 1));
		if($revolution_video_vlog_related_post_wrap == 1){ ?>
                <div class="related-post">
                    
                    <h2 class="post-title"><?php esc_html_e(get_theme_mod('revolution_video_vlog_related_post_text', __('Related Post', 'revolution-video-vlog'))); ?></h2>
                    <?php
                    $revolution_video_vlog_cat_post_args = array(
                        'category__in' => $revolution_video_vlog_category_ids,
                        'post__not_in' => array($post_id),
                        'post_type' => 'post',
                        'posts_per_page' =>  get_theme_mod( 'revolution_video_vlog_related_post_count', '3' ),
                        'post_status' => 'publish',
						'orderby'           => 'rand',
                        'ignore_sticky_posts' => true
                    );
                    $revolution_video_vlog_featured_query = new WP_Query($revolution_video_vlog_cat_post_args);
                    ?>
                    <div class="rel-post-wrap">
                        <?php
                        if ($revolution_video_vlog_featured_query->have_posts()) :

                        while ($revolution_video_vlog_featured_query->have_posts()) : $revolution_video_vlog_featured_query->the_post();
                            ?>
							<div class="card-item rel-card-item">
								<div class="card-content">
									<?php if ( has_post_thumbnail() ) { ?>
										<div class="card-media">
											<?php revolution_video_vlog_post_thumbnail(); ?>
										</div>
									<?php } else {
										// Fallback default image
										$revolution_video_vlog_default_post_thumbnail = get_template_directory_uri() . '/revolution/assets/image/slider1.png';
										echo '<img class="default-post-img" src="' . esc_url( $revolution_video_vlog_default_post_thumbnail ) . '" alt="' . esc_attr( get_the_title() ) . '">';
									} ?>
									<div class="entry-title">
										<h3>
											<a href="<?php the_permalink() ?>">
												<?php the_title(); ?>
											</a>
										</h3>
									</div>
									<div class="entry-meta">
										<?php
										revolution_video_vlog_posted_on();
										revolution_video_vlog_posted_by();
										?>
									</div>
								</div>
							</div>
                        <?php
                        endwhile;
                        ?>
                <?php
                endif;
                wp_reset_postdata();
                ?>
                </div>
                <?php } ?>
                <?php
            }
        }
    }
endif;
add_action('revolution_video_vlog_related_posts', 'revolution_video_vlog_related_post', 10, 1);

//Excerpt 
function revolution_video_vlog_excerpt_function($revolution_video_vlog_excerpt_count = 35) {
    $revolution_video_vlog_excerpt = get_the_excerpt();
    $revolution_video_vlog_text_excerpt = wp_strip_all_tags($revolution_video_vlog_excerpt);
    $revolution_video_vlog_excerpt_limit = (int) get_theme_mod('revolution_video_vlog_excerpt_limit', $revolution_video_vlog_excerpt_count);
    $revolution_video_vlog_words = preg_split('/\s+/', $revolution_video_vlog_text_excerpt); 
    $revolution_video_vlog_trimmed_words = array_slice($revolution_video_vlog_words, 0, $revolution_video_vlog_excerpt_limit);
    $revolution_video_vlog_theme_excerpt = implode(' ', $revolution_video_vlog_trimmed_words);

    return $revolution_video_vlog_theme_excerpt;
}

// Add admin notice
function revolution_video_vlog_admin_notice() { 
    global $pagenow;
    $revolution_video_vlog_theme_args      = wp_get_theme();
    $revolution_video_vlog_meta            = get_option( 'revolution_video_vlog_admin_notice' );
    $name            = $revolution_video_vlog_theme_args->__get( 'Name' );
    $revolution_video_vlog_current_screen  = get_current_screen();

    if( !$revolution_video_vlog_meta ){
	    if( is_network_admin() ){
	        return;
	    }

	    if( ! current_user_can( 'manage_options' ) ){
	        return;
	    } 
		
		if( $revolution_video_vlog_current_screen->base !== 'appearance_page_revolution_video_vlog_guide' && 
            $revolution_video_vlog_current_screen->base !== 'toplevel_page_revolutionvideovlog-demoimport' ) { ?>

            <div class="notice notice-success revolution-video-vlog-welcome-notice">
                <p class="revolution-video-vlog-dismiss-link">
                    <strong>
                        <a href="<?php echo esc_url( add_query_arg( 'revolution_video_vlog_admin_notice', '1' ) ); ?>">
                            <?php esc_html_e( 'Dismiss', 'revolution-video-vlog' ); ?>
                        </a>
                    </strong>
                </p>

                <div class="revolution-video-vlog-welcome-notice-wrap">
                    <h2 class="revolution-video-vlog-notice-title">
                        <span class="dashicons dashicons-admin-home"></span> 
                        <?php 
                            $revolution_video_vlog_theme_name = wp_get_theme()->get( 'Name' );
                            /* translators: %s!: Theme Name. */
                            echo esc_html( sprintf( __( 'Welcome to the free theme: %s!', 'revolution-video-vlog' ), $revolution_video_vlog_theme_name ) );
                        ?>
                    </h2>
                    <p class="revolution-video-vlog-notice-desc">
                        <?php esc_html_e( 'Get started by exploring the features of your new theme. Customize your design, add your content, and create a site that fits your vision.', 'revolution-video-vlog' ); ?>
                    </p>

                    <div class="revolution-video-vlog-welcome-info">
                        <div class="revolution-video-vlog-welcome-thumb">
                            <img src="<?php echo esc_url( get_stylesheet_directory_uri() . '/screenshot.png' ); ?>" alt="<?php esc_attr_e( 'Theme Screenshot', 'revolution-video-vlog' ); ?>">
                        </div>

                        <div class="revolution-video-vlog-welcome-import">
                            <h3><span class="dashicons dashicons-download"></span> <?php esc_html_e( 'Quick Start: Import Demo', 'revolution-video-vlog' ); ?></h3>
                            <p><?php esc_html_e( 'Use the Demo Importer to quickly set up your site with a pre-made layout. Get a complete site in minutes.', 'revolution-video-vlog' ); ?></p>
                            <p><a class="button info-link button-primary" href="<?php echo esc_url( admin_url( 'themes.php?page=revolutionvideovlog-demoimport' ) ); ?>"><?php esc_html_e( 'Go to Demo Importer', 'revolution-video-vlog' ); ?></a></p>
                        </div>

                        <div class="revolution-video-vlog-welcome-getting-started">
                            <h3><span class="dashicons dashicons-art"></span> <?php esc_html_e( 'Customize Your Theme', 'revolution-video-vlog' ); ?></h3>
                            <p><?php esc_html_e( 'Want to make it truly yours? Explore the Getting Started Guide to personalize your site to suit your needs.', 'revolution-video-vlog' ); ?></p>
                            <p><a class="info-link button" href="<?php echo esc_url( admin_url( 'themes.php?page=revolution-video-vlog-getstart-page' ) ); ?>"><?php esc_html_e( 'View Getting Started Guide', 'revolution-video-vlog' ); ?></a></p>
                        </div>
                    </div>
                </div>
            </div>

            <?php
        }

	}
}

add_action( 'admin_notices', 'revolution_video_vlog_admin_notice' );

if( ! function_exists( 'revolution_video_vlog_update_admin_notice' ) ) :
/**
 * Updating admin notice on dismiss
*/
function revolution_video_vlog_update_admin_notice(){
    if ( isset( $_GET['revolution_video_vlog_admin_notice'] ) && $_GET['revolution_video_vlog_admin_notice'] = '1' ) {
        update_option( 'revolution_video_vlog_admin_notice', true );
    }
}
endif;
add_action( 'admin_init', 'revolution_video_vlog_update_admin_notice' );


add_action('after_switch_theme', 'revolution_video_vlog_setup_options');
function revolution_video_vlog_setup_options () {
    update_option('revolution_video_vlog_admin_notice', FALSE );
}

/**
 * Checkbox sanitization callback example.
 *
 * Sanitization callback for 'checkbox' type controls. This callback sanitizes `$revolution_video_vlog_checked`
 * as a boolean value, either TRUE or FALSE.
 */
function revolution_video_vlog_sanitize_checkbox($revolution_video_vlog_checked){
    // Boolean check.
    return ((isset($revolution_video_vlog_checked) && true == $revolution_video_vlog_checked) ? true : false);
}

function revolution_video_vlog_sanitize_choices( $revolution_video_vlog_input, $revolution_video_vlog_setting ) {
    global $wp_customize; 
    $revolution_video_vlog_control = $wp_customize->get_control( $revolution_video_vlog_setting->id ); 
    if ( array_key_exists( $revolution_video_vlog_input, $revolution_video_vlog_control->choices ) ) {
        return $revolution_video_vlog_input;
    } else {
        return $revolution_video_vlog_setting->default;
    }
}

/* Excerpt Limit Begin */
function revolution_video_vlog_string_limit_words($string, $revolution_video_vlog_word_limit) {
	$revolution_video_vlog_words = explode(' ', $string, ($revolution_video_vlog_word_limit + 1));
	if(count($revolution_video_vlog_words) > $revolution_video_vlog_word_limit)
	array_pop($revolution_video_vlog_words);
	return implode(' ', $revolution_video_vlog_words);
}

/**
 * Implement the Custom Header feature.
 */
require get_template_directory() . '/revolution/inc/custom-header.php';

/**
 * Custom template tags for this theme.
 */
require get_template_directory() . '/revolution/inc/template-tags.php';

/**
 * Functions which enhance the theme by hooking into WordPress.
 */
require get_template_directory() . '/revolution/inc/template-functions.php';

/**
 * Customizer additions.
 */
require get_template_directory() . '/revolution/inc/customizer.php';

/**
 * Load Jetpack compatibility file.
 */
if ( defined( 'JETPACK__VERSION' ) ) {
	require get_template_directory() . '/revolution/inc/jetpack.php';

}

/**
 * Breadcrumb File.
 */
require get_template_directory() . '/revolution/inc/breadcrumbs.php';

/**
 * Custom typography options for this theme.
 */
require get_template_directory() . '/revolution/inc/typography-options.php';

//////////////////////////////////////////////   Function for Translation Error   //////////////////////////////////////////////////////
function revolution_video_vlog_enqueue_function() {

	/**
	* GET START.
	*/
	require get_template_directory() . '/getstarted/revolution_video_vlog_about_page.php';

	/**
	* DEMO IMPORT.
	*/
	require get_template_directory() . '/demo-import/revolution_video_vlog_config_file.php';

	define('REVOLUTION_VIDEO_VLOG_FREE_SUPPORT',__('https://wordpress.org/support/theme/revolution-video-vlog/','revolution-video-vlog'));
	define('REVOLUTION_VIDEO_VLOG_PRO_SUPPORT',__('https://www.revolutionwp.com/pages/community/','revolution-video-vlog'));
	define('REVOLUTION_VIDEO_VLOG_REVIEW',__('https://wordpress.org/support/theme/revolution-video-vlog/reviews/#new-post','revolution-video-vlog'));
	define('REVOLUTION_VIDEO_VLOG_BUY_NOW',__('https://www.revolutionwp.com/products/vlog-wordpress-theme','revolution-video-vlog'));
	define('REVOLUTION_VIDEO_VLOG_LIVE_DEMO',__('https://demo.revolutionwp.com/revolution-video-vlog-pro/','revolution-video-vlog'));
	define('REVOLUTION_VIDEO_VLOG_PRO_DOC',__('https://demo.revolutionwp.com/wpdocs/revolution-video-vlog-pro/','revolution-video-vlog'));
	define('REVOLUTION_VIDEO_VLOG_LITE_DOC',__('https://demo.revolutionwp.com/wpdocs/revolution-video-vlog-free','revolution-video-vlog'));

}
add_action( 'after_setup_theme', 'revolution_video_vlog_enqueue_function' );

function revolution_video_vlog_remove_customize_register() {
    global $wp_customize;

    $wp_customize->remove_setting( 'display_header_text' );
    $wp_customize->remove_control( 'display_header_text' );

}

add_action( 'customize_register', 'revolution_video_vlog_remove_customize_register', 11 );

/**
 * WooCommerce custom filters
 */
add_filter('loop_shop_columns', 'revolution_video_vlog_loop_columns');

if (!function_exists('revolution_video_vlog_loop_columns')) {

	function revolution_video_vlog_loop_columns() {

		$revolution_video_vlog_columns = get_theme_mod( 'revolution_video_vlog_per_columns', 3 );

		return $revolution_video_vlog_columns;
	}
}

/************************************************************************************/

add_filter( 'loop_shop_per_page', 'revolution_video_vlog_per_page', 20 );

function revolution_video_vlog_per_page( $revolution_video_vlog_cols ) {

  	$revolution_video_vlog_cols = get_theme_mod( 'revolution_video_vlog_product_per_page', 9 );

	return $revolution_video_vlog_cols;
}

/************************************************************************************/

add_filter( 'woocommerce_output_related_products_args', 'revolution_video_vlog_products_args' );

function revolution_video_vlog_products_args( $revolution_video_vlog_args ) {

    $revolution_video_vlog_args['posts_per_page'] = get_theme_mod( 'custom_related_products_number', 6 );

    $revolution_video_vlog_args['columns'] = get_theme_mod( 'custom_related_products_number_per_row', 3 );

    return $revolution_video_vlog_args;
}

/************************************************************************************/

/**
 * Custom logo
 */

function revolution_video_vlog_custom_css() {
?>
	<style type="text/css" id="custom-theme-colors" >
        :root {
           
            --revolution_video_vlog_logo_width: <?php echo absint(get_theme_mod('revolution_video_vlog_logo_width')); ?> ;   
        }
        .main-header .site-branding {
            max-width:<?php echo esc_html(get_theme_mod('revolution_video_vlog_logo_width')); ?>px ;    
        }         
	</style>
<?php
}
add_action( 'wp_head', 'revolution_video_vlog_custom_css' );

function get_changelog_from_readme() {
    $revolution_video_vlog_file_path = get_template_directory() . '/readme.txt'; // Adjust path if necessary

    if (file_exists($revolution_video_vlog_file_path)) {
        $revolution_video_vlog_content = file_get_contents($revolution_video_vlog_file_path);

        // Extract changelog section
        $revolution_video_vlog_changelog_start = strpos($revolution_video_vlog_content, "== Changelog ==");
        $revolution_video_vlog_changelog = substr($revolution_video_vlog_content, $revolution_video_vlog_changelog_start);

        // Split changelog into versions
        preg_match_all('/\*\s([\d\.]+)\s-\s(.+?)\n((?:\t-\s.+?\n)+)/', $revolution_video_vlog_changelog, $revolution_video_vlog_matches, PREG_SET_ORDER);
        
        return $revolution_video_vlog_matches;
    }
    return [];
}